{
    "scan": {
        "analyzer-version-clang": "18.1.3",
        "analyzer-version-cppcheck": "2.13.0",
        "analyzer-version-gcc": "14.0.1",
        "analyzer-version-gcc-analyzer": "14.0.1",
        "analyzer-version-shellcheck": "0.10.0",
        "enabled-plugins": "clang, cppcheck, gcc, shellcheck",
        "exit-code": 0,
        "host": "ip-172-16-1-144.us-west-2.compute.internal",
        "mock-config": "fedora-41-x86_64",
        "project-name": "pciutils-3.11.1-1.fc40",
        "store-results-to": "/tmp/tmpx3af_eco/pciutils-3.11.1-1.fc40.tar.xz",
        "time-created": "2024-04-22 11:19:37",
        "time-finished": "2024-04-22 11:21:34",
        "tool": "csmock",
        "tool-args": "'/usr/bin/csmock' '-r' 'fedora-41-x86_64' '-t' 'cppcheck,gcc,clang,shellcheck' '-o' '/tmp/tmpx3af_eco/pciutils-3.11.1-1.fc40.tar.xz' '--gcc-analyze' '/tmp/tmpx3af_eco/pciutils-3.11.1-1.fc40.src.rpm'",
        "tool-version": "csmock-3.5.3-1.el9"
    },
    "defects": [
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 456,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/usr/sbin/update-pciids",
                    "line": 8,
                    "column": 1,
                    "event": "warning[SC2209]",
                    "message": "Use var=$(command) to assign output (or quote to assign string).",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    6|   DEST=/usr/share/hwdata/pci.ids",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    7|   PCI_COMPRESSED_IDS=",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    8|-> GREP=grep",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    9|   VERSION=3.11.1",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   10|   USER_AGENT=update-pciids/$VERSION",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 664,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/common.c",
                    "line": 28,
                    "event": "error[va_end_missing]",
                    "message": "va_list 'args' was opened but not closed by va_end().",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   26|     fputc('\\n', stderr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   27|     exit(1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   28|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   29|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   30|   void *",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 465,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/ecam.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘validate_addrs’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/ecam.c",
                    "line": 635,
                    "column": 10,
                    "event": "warning[-Wanalyzer-deref-before-check]",
                    "message": "check of ‘addrs’ for NULL after already dereferencing it",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/ecam.c",
                    "line": 912,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘ecam_init’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/ecam.c",
                    "line": 932,
                    "column": 8,
                    "event": "note",
                    "message": "(2) calling ‘validate_addrs’ from ‘ecam_init’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/ecam.c",
                    "line": 630,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘validate_addrs’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/ecam.c",
                    "line": 632,
                    "column": 8,
                    "event": "note",
                    "message": "(4) pointer ‘addrs’ is dereferenced here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/ecam.c",
                    "line": 632,
                    "column": 6,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/ecam.c",
                    "line": 635,
                    "column": 10,
                    "event": "note",
                    "message": "(7) pointer ‘addrs’ is checked for NULL here but it was already dereferenced at (4)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  633|       return 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  634|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  635|->   while (addrs)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  636|       if (!parse_next_addrs(addrs, &addrs, NULL, NULL, NULL, NULL, NULL))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  637|         return 0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 117,
                    "column": 9,
                    "event": "warning[core.NullDereference]",
                    "message": "Dereference of null pointer (loaded from variable 'outp')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 324,
                    "column": 98,
                    "event": "note",
                    "message": "Passing value via 1st parameter 'f'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 41,
                    "column": 50,
                    "event": "note",
                    "message": "expanded from macro 'STATIC_ALIAS'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 324,
                    "column": 74,
                    "event": "note",
                    "message": "Calling 'pci_filter_parse_id_v38'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 41,
                    "column": 50,
                    "event": "note",
                    "message": "expanded from macro 'STATIC_ALIAS'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 176,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'err' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 176,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 179,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 179,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 182,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 185,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 188,
                    "column": 35,
                    "event": "note",
                    "message": "Passing value via 2nd parameter 'outp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 188,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'parse_hex_field'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 78,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 78,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 83,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'maskp' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 83,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 83,
                    "column": 17,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 83,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 83,
                    "column": 35,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 83,
                    "column": 49,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 86,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 117",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/filter.c",
                    "line": 117,
                    "column": 9,
                    "event": "note",
                    "message": "Dereference of null pointer (loaded from variable 'outp')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  115|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  116|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  117|->   *outp = out;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  118|     if (maskp)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  119|       *maskp = mask;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘pci_new_load_name_list’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 286,
                    "column": 14,
                    "event": "warning[-Wanalyzer-possible-null-argument]",
                    "message": "use of possibly-NULL ‘temp’ where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 268,
                    "column": 3,
                    "event": "note",
                    "message": "(1) when ‘strncpy’ copies the full source string",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 273,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 282,
                    "column": 15,
                    "event": "note",
                    "message": "(4) when ‘strstr’ returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 282,
                    "column": 14,
                    "event": "note",
                    "message": "(5) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 284,
                    "column": 25,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 285,
                    "column": 21,
                    "event": "note",
                    "message": "(7) this call could return NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/names-parse.c",
                    "line": 286,
                    "column": 14,
                    "event": "note",
                    "message": "(8) argument 1 (‘temp’) from (7) could be NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<built-in>",
                    "line": 0,
                    "event": "note",
                    "message": "argument 1 of ‘__builtin_memset’ must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  284|                tempsize = strnlen(new_id_path, PATH_MAX) + dp->d_reclen + 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  285|                temp = malloc(tempsize);      /* This malloced memory is freed in the function pci_set_name_list_path() */ ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  286|->              memset(temp, 0, tempsize);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  287|                strncpy(temp, new_id_path, (strnlen(new_id_path, PATH_MAX))+1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  288|                strncat(temp, dp->d_name, PATH_MAX - strnlen(temp, PATH_MAX));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘proc_scan’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 98,
                    "column": 10,
                    "event": "warning[-Wanalyzer-file-leak]",
                    "message": "leak of FILE ‘fopen(&buf, \"r\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 65,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 67,
                    "column": 7,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 67,
                    "column": 7,
                    "event": "note",
                    "message": "(3) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 68,
                    "column": 6,
                    "event": "note",
                    "message": "(4) assuming ‘fopen(&buf, \"r\")’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 68,
                    "column": 6,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 70,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 72,
                    "column": 27,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 98,
                    "column": 10,
                    "event": "note",
                    "message": "(9) ‘fopen(&buf, \"r\")’ leaks here; was opened at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|   \t     &offset);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|   #undef F",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|->       if (cnt != 9 && cnt != 10 && cnt != 17)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   99|   \ta->error(\"proc: parse error (read only %d items)\", cnt);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  100|         d->bus = dfn >> 8U;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 98,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘fopen(&buf, \"r\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 65,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 67,
                    "column": 7,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 67,
                    "column": 7,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 68,
                    "column": 6,
                    "event": "note",
                    "message": "(4) assuming ‘fopen(&buf, \"r\")’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 68,
                    "column": 6,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 70,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 72,
                    "column": 27,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 98,
                    "column": 10,
                    "event": "note",
                    "message": "(9) ‘fopen(&buf, \"r\")’ leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|   \t     &offset);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|   #undef F",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|->       if (cnt != 9 && cnt != 10 && cnt != 17)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   99|   \ta->error(\"proc: parse error (read only %d items)\", cnt);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  100|         d->bus = dfn >> 8U;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘proc_setup’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 152,
                    "column": 10,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘*a.fd’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 148,
                    "column": 10,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 150,
                    "column": 19,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 151,
                    "column": 15,
                    "event": "note",
                    "message": "(3) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 152,
                    "column": 10,
                    "event": "note",
                    "message": "(4) ‘*a.fd’ leaks here; was opened at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  150|         a->fd_rw = a->writeable || rw;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  151|         a->fd = open(buf, a->fd_rw ? O_RDWR : O_RDONLY);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|->       if (a->fd < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  153|   \t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|   \t  e = snprintf(buf, sizeof(buf), \"%s/%04x:%02x/%02x.%d\",",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 159,
                    "column": 17,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘*a.fd’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 148,
                    "column": 10,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 150,
                    "column": 19,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 152,
                    "column": 10,
                    "event": "note",
                    "message": "(3) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 156,
                    "column": 52,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 157,
                    "column": 14,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 159,
                    "column": 30,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 159,
                    "column": 19,
                    "event": "note",
                    "message": "(7) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/proc.c",
                    "line": 159,
                    "column": 17,
                    "event": "note",
                    "message": "(8) ‘*a.fd’ leaks here; was opened at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  157|   \t  if (e < 0 || e >= (int) sizeof(buf))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|   \t    a->error(\"File name too long\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  159|-> \t  a->fd = open(buf, a->fd_rw ? O_RDWR : O_RDONLY);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  161|         if (a->fd < 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 10,
                    "event": "warning[-Wanalyzer-file-leak]",
                    "message": "leak of FILE ‘fopen(&namebuf, \"r\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 335,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 339,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 346,
                    "column": 11,
                    "event": "note",
                    "message": "(3) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 353,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 368,
                    "column": 11,
                    "event": "note",
                    "message": "(6) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 381,
                    "column": 11,
                    "event": "note",
                    "message": "(8) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 383,
                    "column": 11,
                    "event": "note",
                    "message": "(10) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 115,
                    "column": 23,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 384,
                    "column": 11,
                    "event": "note",
                    "message": "(14) calling ‘sysfs_get_resources’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 153,
                    "column": 1,
                    "event": "note",
                    "message": "(15) entry to ‘sysfs_get_resources’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 163,
                    "column": 3,
                    "event": "note",
                    "message": "(16) calling ‘sysfs_obj_name’ from ‘sysfs_get_resources’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 81,
                    "column": 1,
                    "event": "note",
                    "message": "(17) entry to ‘sysfs_obj_name’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 85,
                    "column": 6,
                    "event": "note",
                    "message": "(18) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 87,
                    "column": 1,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 163,
                    "column": 3,
                    "event": "note",
                    "message": "(20) returning to ‘sysfs_get_resources’ from ‘sysfs_obj_name’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 164,
                    "column": 10,
                    "event": "note",
                    "message": "(21) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 165,
                    "column": 6,
                    "event": "note",
                    "message": "(22) assuming ‘fopen(&namebuf, \"r\")’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 165,
                    "column": 6,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 167,
                    "column": 17,
                    "event": "note",
                    "message": "(25) following ‘true’ branch (when ‘i != 18’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 12,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 10,
                    "event": "note",
                    "message": "(27) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 11,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 10,
                    "event": "note",
                    "message": "(29) ‘fopen(&namebuf, \"r\")’ leaks here; was opened at (21)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  170|         if (!fgets(buf, sizeof(buf), file))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  171|   \tbreak;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|->       if (sscanf(buf, \"%llx %llx %llx\", &start, &end, &flags) != 3)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|   \ta->error(\"Syntax error in %s\", namebuf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|         if (end > start)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘fopen(&namebuf, \"r\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 335,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 339,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 346,
                    "column": 11,
                    "event": "note",
                    "message": "(3) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 353,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 368,
                    "column": 11,
                    "event": "note",
                    "message": "(6) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 381,
                    "column": 11,
                    "event": "note",
                    "message": "(8) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 383,
                    "column": 11,
                    "event": "note",
                    "message": "(10) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 115,
                    "column": 23,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 384,
                    "column": 11,
                    "event": "note",
                    "message": "(14) calling ‘sysfs_get_resources’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 153,
                    "column": 1,
                    "event": "note",
                    "message": "(15) entry to ‘sysfs_get_resources’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 163,
                    "column": 3,
                    "event": "note",
                    "message": "(16) calling ‘sysfs_obj_name’ from ‘sysfs_get_resources’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 81,
                    "column": 1,
                    "event": "note",
                    "message": "(17) entry to ‘sysfs_obj_name’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 85,
                    "column": 6,
                    "event": "note",
                    "message": "(18) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 87,
                    "column": 1,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 163,
                    "column": 3,
                    "event": "note",
                    "message": "(20) returning to ‘sysfs_get_resources’ from ‘sysfs_obj_name’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 164,
                    "column": 10,
                    "event": "note",
                    "message": "(21) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 165,
                    "column": 6,
                    "event": "note",
                    "message": "(22) assuming ‘fopen(&namebuf, \"r\")’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 165,
                    "column": 6,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 167,
                    "column": 17,
                    "event": "note",
                    "message": "(25) following ‘true’ branch (when ‘i != 18’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 12,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 10,
                    "event": "note",
                    "message": "(27) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 11,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 10,
                    "event": "note",
                    "message": "(29) ‘fopen(&namebuf, \"r\")’ leaks here; was allocated at (21)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  170|         if (!fgets(buf, sizeof(buf), file))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  171|   \tbreak;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|->       if (sscanf(buf, \"%llx %llx %llx\", &start, &end, &flags) != 3)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|   \ta->error(\"Syntax error in %s\", namebuf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|         if (end > start)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 174,
                    "column": 15,
                    "event": "warning[-Wanalyzer-file-leak]",
                    "message": "leak of FILE ‘fopen(&namebuf, \"r\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 335,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 339,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 346,
                    "column": 11,
                    "event": "note",
                    "message": "(3) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 353,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 368,
                    "column": 11,
                    "event": "note",
                    "message": "(6) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 381,
                    "column": 11,
                    "event": "note",
                    "message": "(8) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 383,
                    "column": 11,
                    "event": "note",
                    "message": "(10) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 115,
                    "column": 23,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 384,
                    "column": 11,
                    "event": "note",
                    "message": "(14) calling ‘sysfs_get_resources’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 153,
                    "column": 1,
                    "event": "note",
                    "message": "(15) entry to ‘sysfs_get_resources’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 163,
                    "column": 3,
                    "event": "note",
                    "message": "(16) calling ‘sysfs_obj_name’ from ‘sysfs_get_resources’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 81,
                    "column": 1,
                    "event": "note",
                    "message": "(17) entry to ‘sysfs_obj_name’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 85,
                    "column": 6,
                    "event": "note",
                    "message": "(18) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 87,
                    "column": 1,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 163,
                    "column": 3,
                    "event": "note",
                    "message": "(20) returning to ‘sysfs_get_resources’ from ‘sysfs_obj_name’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 164,
                    "column": 10,
                    "event": "note",
                    "message": "(21) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 165,
                    "column": 6,
                    "event": "note",
                    "message": "(22) assuming ‘fopen(&namebuf, \"r\")’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 165,
                    "column": 6,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 167,
                    "column": 17,
                    "event": "note",
                    "message": "(25) following ‘true’ branch (when ‘i != 18’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 12,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 10,
                    "event": "note",
                    "message": "(27) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 11,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 10,
                    "event": "note",
                    "message": "(29) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 174,
                    "column": 15,
                    "event": "note",
                    "message": "(30) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 178,
                    "column": 10,
                    "event": "note",
                    "message": "(31) following ‘true’ branch (when ‘i <= 5’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 180,
                    "column": 23,
                    "event": "note",
                    "message": "(32) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 167,
                    "column": 17,
                    "event": "note",
                    "message": "(33) following ‘true’ branch (when ‘i != 18’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 12,
                    "event": "note",
                    "message": "(34) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 10,
                    "event": "note",
                    "message": "(35) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 11,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 174,
                    "column": 15,
                    "event": "note",
                    "message": "(37) ‘fopen(&namebuf, \"r\")’ leaks here; was opened at (21)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|         if (sscanf(buf, \"%llx %llx %llx\", &start, &end, &flags) != 3)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|   \ta->error(\"Syntax error in %s\", namebuf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|->       if (end > start)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  175|   \tsize = end - start + 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  176|         else",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 174,
                    "column": 15,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘fopen(&namebuf, \"r\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 335,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 339,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 346,
                    "column": 11,
                    "event": "note",
                    "message": "(3) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 353,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 368,
                    "column": 11,
                    "event": "note",
                    "message": "(6) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 381,
                    "column": 11,
                    "event": "note",
                    "message": "(8) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 383,
                    "column": 11,
                    "event": "note",
                    "message": "(10) inlined call to ‘want_fill’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 110,
                    "column": 15,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/internal.h",
                    "line": 115,
                    "column": 23,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sysfs_get_resources’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 384,
                    "column": 11,
                    "event": "note",
                    "message": "(14) calling ‘sysfs_get_resources’ from ‘sysfs_fill_info’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 153,
                    "column": 1,
                    "event": "note",
                    "message": "(15) entry to ‘sysfs_get_resources’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 163,
                    "column": 3,
                    "event": "note",
                    "message": "(16) calling ‘sysfs_obj_name’ from ‘sysfs_get_resources’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 81,
                    "column": 1,
                    "event": "note",
                    "message": "(17) entry to ‘sysfs_obj_name’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 85,
                    "column": 6,
                    "event": "note",
                    "message": "(18) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 87,
                    "column": 1,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 163,
                    "column": 3,
                    "event": "note",
                    "message": "(20) returning to ‘sysfs_get_resources’ from ‘sysfs_obj_name’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 164,
                    "column": 10,
                    "event": "note",
                    "message": "(21) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 165,
                    "column": 6,
                    "event": "note",
                    "message": "(22) assuming ‘fopen(&namebuf, \"r\")’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 165,
                    "column": 6,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 167,
                    "column": 17,
                    "event": "note",
                    "message": "(25) following ‘true’ branch (when ‘i != 18’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 12,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 10,
                    "event": "note",
                    "message": "(27) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 11,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 10,
                    "event": "note",
                    "message": "(29) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 174,
                    "column": 15,
                    "event": "note",
                    "message": "(30) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 178,
                    "column": 10,
                    "event": "note",
                    "message": "(31) following ‘true’ branch (when ‘i <= 5’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 180,
                    "column": 23,
                    "event": "note",
                    "message": "(32) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 167,
                    "column": 17,
                    "event": "note",
                    "message": "(33) following ‘true’ branch (when ‘i != 18’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 12,
                    "event": "note",
                    "message": "(34) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 170,
                    "column": 10,
                    "event": "note",
                    "message": "(35) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 172,
                    "column": 11,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/lib/sysfs.c",
                    "line": 174,
                    "column": 15,
                    "event": "note",
                    "message": "(37) ‘fopen(&namebuf, \"r\")’ leaks here; was allocated at (21)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|         if (sscanf(buf, \"%llx %llx %llx\", &start, &end, &flags) != 3)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|   \ta->error(\"Syntax error in %s\", namebuf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|->       if (end > start)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  175|   \tsize = end - start + 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  176|         else",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 758,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/ls-tree.c",
                    "line": 263,
                    "event": "error[ctuPointerArith]",
                    "message": "Pointer arithmetic overflow; 'line' buffer size is 1024",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  261|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  262|     va_list args;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  263|->   int space = line + LINE_BUF_SIZE - 1 - p;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  265|     if (space <= 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 664,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 459,
                    "event": "error[va_end_missing]",
                    "message": "va_list 'args' was opened but not closed by va_end().",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  457|     fprintf(stderr, \".\\nTry `setpci --help' for more information.\\n\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  458|     exit(1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  459|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  460|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  461|   static int",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 752,
                    "column": 11,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 825,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'parse_ops'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 793,
                    "column": 10,
                    "event": "note",
                    "message": "'i' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 793,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 797,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 799,
                    "column": 9,
                    "event": "note",
                    "message": "'group' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 799,
                    "column": 15,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 793,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming 'i' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 793,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 797,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 797,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 805,
                    "column": 9,
                    "event": "note",
                    "message": "'group' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 805,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 807,
                    "column": 4,
                    "event": "note",
                    "message": "Calling 'parse_op'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 668,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'value' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 668,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 670,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 670,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'number' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 670,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 672,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 672,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'width' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 672,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 674,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 674,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'offset' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 674,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 679,
                    "column": 7,
                    "event": "note",
                    "message": "'value' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 679,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 681,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 681,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 684,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 685,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 685,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 684,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 690",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 697,
                    "column": 7,
                    "event": "note",
                    "message": "'width' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 697,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 717,
                    "column": 7,
                    "event": "note",
                    "message": "'number' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 717,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 730,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'width' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 730,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 734,
                    "column": 7,
                    "event": "note",
                    "message": "'offset' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 734,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 743,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'addr' is < 4096",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 743,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 743,
                    "column": 51,
                    "event": "note",
                    "message": "'n' is 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 743,
                    "column": 51,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 743,
                    "column": 29,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 743,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 745,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 745,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 749,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 752,
                    "column": 7,
                    "event": "note",
                    "message": "Value assigned to 'e'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 753,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 753,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'e' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 753,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 755,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 755,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 755,
                    "column": 44,
                    "event": "note",
                    "message": "Assuming pointer value is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 755,
                    "column": 44,
                    "event": "note",
                    "message": "Assuming 'f' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 755,
                    "column": 46,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 758,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'll' is <= 'lim'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 758,
                    "column": 20,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 761,
                    "column": 11,
                    "event": "note",
                    "message": "'f' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 761,
                    "column": 13,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 772,
                    "column": 7,
                    "event": "note",
                    "message": "Null pointer value stored to 'value'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 749,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "pciutils-3.11.1/setpci.c",
                    "line": 752,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  750|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  751|         unsigned int ll, lim;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  752|->       e = strchr(value, ',');",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  753|         if (e)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  754|   \t*e++ = 0;",
                    "verbosity_level": 1
                }
            ]
        }
    ]
}
